#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define all(a) a.begin(), a.end()

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    ll s;
    cin >> s;
    for (int mask = 0; mask < (1 << n); mask++) {
        vector<ll> col(m);
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) continue;
            for (int j = 0; j < m; j++) {
                col[j] += a[i][j];
            }
        }
        int need = -1;
        if (m < 8) {
            for (int mask2 = 0; mask2 < (1 << m); mask2++) {
                ll sum = 0;
                for (int b = 0; b < m; b++) {
                    if (!(mask2 & (1 << b))) {
                        sum += col[b];
                    }
                }
                if (sum == s) {
                    need = mask2;
                }
            }
        } else {
            int sz1 = m / 2, sz2 = (m + 1) / 2;
            vector<pair<ll, int>> arr1, arr2;
            for (int mask2 = 0; mask2 < (1 << sz1); mask2++) {
                ll sum = 0;
                for (int b = 0; b < sz1; b++) {
                    if (!(mask2 & (1 << b))) {
                        sum += col[b];
                    }
                }
                arr1.pb({sum, mask2});
            }
            for (int mask2 = 0; mask2 < (1 << sz2); mask2++) {
                ll sum = 0;
                for (int b = 0; b < sz2; b++) {
                    if (!(mask2 & (1 << b))) {
                        sum += col[b + sz1];
                    }
                }
                arr2.pb({sum, mask2 * (1 << sz1)});
            }
            sort(all(arr1)), sort(all(arr2));
            int j = (int)(arr2.size()) - 1;
            for (int i = 0; i < arr1.size(); i++) {
                while (j >= 0 && arr1[i].first + arr2[j].first > s) {
                    j--;
                }
                if (j >= 0 && arr1[i].first + arr2[j].first == s) {
                    need = arr1[i].second | arr2[j].second;
                    break;
                }
            }
        }
        if (need != -1) {
            cout << "YES\n";
            vector<pair<int, int>> u;
            for (int b = 0; b < n; b++) {
                if (mask & (1 << b)) {
                    u.pb({1, b + 1});
                }
            }
            for (int b = 0; b < m; b++) {
                if (need & (1 << b)) {
                    u.pb({2, b + 1});
                }
            }
            cout << u.size() << endl;
            for (auto [a, b] : u) {
                cout << a << ' ' << b << endl;
            }
            return 0;
        }
    }
    cout << "NO\n";
    return 0;
}
