#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define all(a) a.begin(), a.end()

const int N = 2e5 + 10;
vector<int> g[N];
int cnt = 0;
int tin[N], tout[N], par[N], dep[N];

void zhfs(int v, int p) {
    tin[v] = cnt++;
    for (auto u : g[v]) {
        if (u != p) {
            par[u] = v;
            dep[u] = dep[v] + 1;
            zhfs(u, v);
        }
    }
    tout[v] = cnt - 1;
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, t, k;
    cin >> n >> k >> t;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].pb(b);
        g[b].pb(a);
    }
    for (int v = 0; v < n; v++) {
        cnt = 0;
        dep[v] = 0;
        zhfs(v, -1);
        vector<int> arr;
        for (int u = 0; u < n; u++) {
            arr.pb(u);
        }
        sort(all(arr), [&](int a, int b){return dep[a] > dep[b];});
        int l = 0, r = n;
        while (r - l > 1) {
            int mid = (r + l) / 2, kek = 0;
            vector<bool> used(n);
            for (int u : arr) {
                if (dep[u] > mid && !used[tin[u]]) {
                    kek++;
                    int vert = u;
                    for (int j = 0; j < mid - 1; j++) {
                        vert = par[vert];
                    }
                    for (int j = tin[vert]; j <= tout[vert]; j++) {
                        used[j] = 1;
                    }
                }
            }
            if (kek <= k) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cout << r << ' ';
        if (t == 0) break;
    }
    cout << endl;
    return 0;
}
