#include<bits/stdc++.h>

#define ll long long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

using namespace std;

const int N = 1e6 + 10;
vector<int> color(N, -1);
vector<bool> pr(N, 1);

void pre_calc() {
    vector<int> arr;
    for (int i = 2; i < N; i++) {
        if (pr[i]) {
            arr.pb(i);
        }
        for (int j = 2 * i; j < N; j += i) {
            pr[j] = 0;
        }
    }
    for (int i = 1; i < N; i++) {
        if (color[i] != -1) continue;
        vector<bool> colors(2);
        for (int p : arr) {
            if (i * p >= N) break;
            if (color[i * p] != -1) {
                colors[color[i * p]] = 1;
            }
        }
        if (colors[0]) {
            assert(!colors[1]);
            color[i] = 1;
        } else {
            assert(!colors[0]);
            color[i] = 0;
        }
        for (int p : arr) {
            if (i * p >= N) break;
            color[i * p] = color[i] ^ 1;
        }
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    pre_calc();
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cout << color[a[i]] + 1 << ' ';
    }
    cout << endl;
    return 0;
}
